v0.4.42 logging format for OSM integration
[osm/RO.git] / test / basictest.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openmano
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #This script can be used as a basic test of openmano.
25 #WARNING: It destroy the database content
26
27
28 function usage(){
29 echo -e "usage: ${BASH_SOURCE[0]} [OPTIONS] <action>\n test openmano using openvim as a VIM"
30 echo -e " the OPENVIM_HOST, OPENVIM_PORT shell variables indicate openvim location"
31 echo -e " by default localhost:9080"
32 echo -e " <action> is a list of the following items (by default 'reset create delete')"
33 echo -e " reset reset the openmano database content"
34 echo -e " create creates items"
35 echo -e " delete delete created items"
36 echo -e " OPTIONS:"
37 echo -e " -f --force does not prompt for confirmation"
38 echo -e " -h --help shows this help"
39 echo -e " --insert-bashrc insert the created tenant,datacenter variables at"
40 echo -e " ~/.bashrc to be available by openmano CLI"
41 echo -e " --init-openvim if openvim runs locally, an init is called to clean openvim"
42 echo -e " database and add fake hosts"
43 }
44
45 function is_valid_uuid(){
46 echo "$1" | grep -q -E '^[0-9a-f]{8}-([0-9a-f]{4}-){3}[0-9a-f]{12}$' && return 0
47 return 1
48 }
49
50 #detect if is called with a source to use the 'exit'/'return' command for exiting
51 [[ ${BASH_SOURCE[0]} != $0 ]] && _exit="return" || _exit="exit"\1a
52
53
54 #check correct arguments
55 force=""
56 action_list=""
57 insert_bashrc=""
58 init_openvim=""
59 for param in $*
60 do
61 if [[ $param == reset ]] || [[ $param == create ]] || [[ $param == delete ]]
62 then
63 action_list="$action_list $param"
64 elif [[ $param == -h ]] || [[ $param == --help ]]
65 then
66 usage
67 $_exit 0
68 elif [[ $param == -f ]] || [[ $param == --force ]]
69 then
70 force="-f"
71 elif [[ $param == --insert-bashrc ]]
72 then
73 insert_bashrc=y
74 elif [[ $param == --init-openvim ]]
75 then
76 init_openvim=y
77 else
78 echo "invalid argument '$param'? Type -h for help" >&2 && $_exit 1
79 fi
80 done
81
82 DIRNAME=$(dirname $(readlink -f ${BASH_SOURCE[0]}))
83 DIRmano=$(dirname $DIRNAME)
84 DIRscript=${DIRmano}/scripts
85 #by default action should be reset and create
86 [[ -z $action_list ]] && action_list="reset create delete"
87 [[ -z $init_openvim ]] || initopenvim $force || echo "WARNING openvim cannot be initialized. The rest of test can fail!"
88
89 #check openvim client variables are set
90 #fail=""
91 #[[ -z $OPENVIM_HOST ]] && echo "OPENVIM_HOST variable not defined" >&2 && fail=1
92 #[[ -z $OPENVIM_PORT ]] && echo "OPENVIM_PORT variable not defined" >&2 && fail=1
93 #[[ -n $fail ]] && $_exit 1
94
95
96 for action in $action_list
97 do
98 #if [[ $action == "install-openvim" ]]
99 #echo "Installing and starting openvim"
100 #mkdir -p temp
101 #pushd temp
102 #wget https://github.com/nfvlabs/openvim/raw/v0.4/scripts/install-openvim.sh
103 #chmod -x install-openvim.sh
104 #fi
105
106 if [[ $action == "reset" ]]
107 then
108
109 #ask for confirmation if argument is not -f --force
110 force_=y
111 [[ -z $force ]] && read -e -p "WARNING: reset openmano database, content will be lost!!! Continue(y/N) " force_
112 [[ $force_ != y ]] && [[ $force_ != yes ]] && echo "aborted!" && $_exit
113
114 echo "Stopping openmano"
115 $DIRscript/service-openmano.sh mano stop
116 echo "Initializing openmano database"
117 $DIRmano/database_utils/init_mano_db.sh -u mano -p manopw
118 echo "Starting openmano"
119 $DIRscript/service-openmano.sh mano start
120 echo
121
122 elif [[ $action == "delete" ]]
123 then
124 result=`openmano tenant-list TEST-tenant`
125 nfvotenant=`echo $result |gawk '{print $1}'`
126 #check a valid uuid is obtained
127 is_valid_uuid $nfvotenant || ! echo "Tenant TEST-tenant not found. Already delete?" >&2 || $_exit 1
128 export OPENMANO_TENANT=$nfvotenant
129 ${DIRmano}/openmano instance-scenario-delete -f simple-instance || echo "fail"
130 ${DIRmano}/openmano instance-scenario-delete -f complex-instance || echo "fail"
131 ${DIRmano}/openmano instance-scenario-delete -f complex2-instance || echo "fail"
132 ${DIRmano}/openmano scenario-delete -f simple || echo "fail"
133 ${DIRmano}/openmano scenario-delete -f complex || echo "fail"
134 ${DIRmano}/openmano scenario-delete -f complex2 || echo "fail"
135 ${DIRmano}/openmano vnf-delete -f linux || echo "fail"
136 ${DIRmano}/openmano vnf-delete -f dataplaneVNF_2VMs || echo "fail"
137 ${DIRmano}/openmano vnf-delete -f dataplaneVNF2 || echo "fail"
138 ${DIRmano}/openmano vnf-delete -f dataplaneVNF3 || echo "fail"
139 ${DIRmano}/openmano datacenter-detach TEST-dc || echo "fail"
140 ${DIRmano}/openmano datacenter-delete -f TEST-dc || echo "fail"
141 ${DIRmano}/openmano tenant-delete -f TEST-tenant || echo "fail"
142 echo
143
144 elif [[ $action == "create" ]]
145 then
146 printf "%-50s" "Creating openmano tenant 'TEST-tenant': "
147 result=`${DIRmano}/openmano tenant-create TEST-tenant --description="created by basictest.sh"`
148 nfvotenant=`echo $result |gawk '{print $1}'`
149 #check a valid uuid is obtained
150 ! is_valid_uuid $nfvotenant && echo "FAIL" && echo " $result" && $_exit 1
151 export OPENMANO_TENANT=$nfvotenant
152 [[ $insert_bashrc == y ]] && echo -e "\nexport OPENMANO_TENANT=$nfvotenant" >> ~/.bashrc
153 echo $nfvotenant
154
155 printf "%-50s" "Creating datacenter 'TEST-dc' in openmano:"
156 [[ -z $OPENVIM_HOST ]] && OPENVIM_HOST=localhost
157 [[ -z $OPENVIM_PORT ]] && OPENVIM_PORT=9080
158 URL_ADMIN_PARAM=""
159 [[ -n $OPENVIM_ADMIN_PORT ]] && URL_ADMIN_PARAM="--url_admin=http://${$OPENVIM_HOST}:${OPENVIM_ADMIN_PORT}/openvim"
160 result=`${DIRmano}/openmano datacenter-create TEST-dc "http://${OPENVIM_HOST}:${OPENVIM_PORT}/openvim" --type=openvim $URL_ADMIN_PARAM`
161 datacenter=`echo $result |gawk '{print $1}'`
162 #check a valid uuid is obtained
163 ! is_valid_uuid $datacenter && echo "FAIL" && echo " $result" && $_exit 1
164 echo $datacenter
165 export OPENMANO_DATACENTER=$datacenter
166 [[ $insert_bashrc == y ]] && echo -e "\nexport OPENMANO_DATACENTER=$datacenter" >> ~/.bashrc
167
168 printf "%-50s" "Attaching openmano tenant to the datacenter:"
169 result=`${DIRmano}/openmano datacenter-attach TEST-dc`
170 [[ $? != 0 ]] && echo "FAIL" && echo " $result" && $_exit 1
171 echo OK
172
173 printf "%-50s" "Updating external nets in openmano: "
174 result=`${DIRmano}/openmano datacenter-netmap-delete -f --all`
175 [[ $? != 0 ]] && echo "FAIL" && echo " $result" && $_exit 1
176 result=`${DIRmano}/openmano datacenter-netmap-upload -f`
177 [[ $? != 0 ]] && echo "FAIL" && echo " $result" && $_exit 1
178 echo OK
179
180 for VNF in linux dataplaneVNF1 dataplaneVNF2 dataplaneVNF_2VMs dataplaneVNF3
181 do
182 printf "%-50s" "Creating VNF '${VNF}': "
183 result=`$DIRmano/openmano vnf-create $DIRmano/vnfs/examples/${VNF}.yaml`
184 vnf=`echo $result |gawk '{print $1}'`
185 #check a valid uuid is obtained
186 ! is_valid_uuid $vnf && echo FAIL && echo " $result" && $_exit 1
187 echo $vnf
188 done
189 for NS in simple complex complex2
190 do
191 printf "%-50s" "Creating scenario '${NS}':"
192 result=`$DIRmano/openmano scenario-create $DIRmano/scenarios/examples/${NS}.yaml`
193 scenario=`echo $result |gawk '{print $1}'`
194 ! is_valid_uuid $scenario && echo FAIL && echo " $result" && $_exit 1
195 echo $scenario
196 done
197
198 for IS in simple complex complex2
199 do
200 printf "%-50s" "Creating instance-scenario '${IS}':"
201 result=`$DIRmano/openmano instance-scenario-create --scenario ${IS} --name ${IS}-instance`
202 instance=`echo $result |gawk '{print $1}'`
203 ! is_valid_uuid $instance && echo FAIL && echo " $result" && $_exit 1
204 echo $instance
205 done
206
207 echo
208 #echo "Check virtual machines are deployed"
209 #vms_error=`openvim vm-list | grep ERROR | wc -l`
210 #vms=`openvim vm-list | wc -l`
211 #[[ $vms -ne 8 ]] && echo "WARNING: $vms VMs created, must be 8 VMs" >&2 && $_exit 1
212 #[[ $vms_error -gt 0 ]] && echo "WARNING: $vms_error VMs with ERROR" >&2 && $_exit 1
213 fi
214 done
215
216 echo
217 echo DONE
218
219